LeetCode 358 - Rearrange String k Distance Apart


Related:
LeetCode 358 - Rearrange String k Distance Apart
LeetCode 767 - Reorganize String
LeetCode 621 - Task Scheduler
http://blog.csdn.net/jmspan/article/details/51678257
Given a non-empty string str and an integer k, rearrange the string such that the same characters are at least distance k from each other.
All input strings are given in lowercase letters. If it is not possible to rearrange the string, return an empty string "".
Example 1:
str = "aabbcc", k = 3

Result: "abcabc"

The same letters are at least distance 3 from each other.
Example 2:
str = "aaabc", k = 3 

Answer: ""

It is not possible to rearrange the string.
Example 3:
str = "aaadbbcc", k = 2

Answer: "abacabcd"

Another possible answer is: "abcabcda"

The same letters are at least distance 2 from each other.

X. Using Priority Queue
https://tenderleo.gitbooks.io/leetcode-solutions-/GoogleHard/358.html
    public String rearrangeString(String str, int k) {

        if(k == 0) return str;

        int len = str.length();
        Map<Character, Integer> counts = new HashMap<>();
        for(int i=0; i< len; i++){
            char ch = str.charAt(i);
            int n =1;
            if(counts.containsKey(ch)){
                n = counts.get(ch)+1;
            }
            counts.put(ch, n);
        }

        PriorityQueue<Pair> pq = new PriorityQueue<>(10, new Comparator<Pair>(){
            @Override
            public int compare(Pair p1, Pair p2){
                if(p1.cnt != p2.cnt) return p2.cnt - p1.cnt;
                else return  p2.ch - p1.ch; // to ensure the order of the chars with same count, they should show up in same order.
            }
        });

        for(Map.Entry<Character, Integer> entry : counts.entrySet()){
            pq.offer(new Pair(entry.getKey(), entry.getValue()));// pick the most show-up char first.
        }

        StringBuilder sb = new StringBuilder();
        while(!pq.isEmpty()){
            List<Pair> tmp = new ArrayList<>();// this is avoid you pick up same char in the same k-segment.
            int d = Math.min(k, len);
            for(int i=0; i< d; i++){
                if(pq.isEmpty()) return "";
                Pair p = pq.poll();
                sb.append(p.ch);
                if(--p.cnt > 0) tmp.add(p);
                len--;
            }
            for(Pair p : tmp) pq.offer(p);

        }

        return sb.toString();

    }

    class Pair{
        char ch;
        int cnt;
        Pair(char c, int t){
            ch = c;
            cnt = t;
        }
    };
https://github.com/YaokaiYang-assaultmaster/LeetCode/blob/master/LeetcodeAlgorithmQuestions/358.%20Rearrange%20String%20k%20Distance%20Apart.mdhttp://www.programcreek.com/2014/08/leetcode-rearrange-string-k-distance-apart-java/
public String rearrangeString(String str, int k) {
    if(k==0)
        return str;
 
    //initialize the counter for each character
    final HashMap<Character, Integer> map = new HashMap<Character, Integer>();
    for(int i=0; i<str.length(); i++){
        char c = str.charAt(i);
        if(map.containsKey(c)){
            map.put(c, map.get(c)+1);
        }else{
            map.put(c, 1);
        }
    }
 
    //sort the chars by frequency
    PriorityQueue<Character> queue = new PriorityQueue<Character>(new Comparator<Character>(){
        public int compare(Character c1, Character c2){
            if(map.get(c2).intValue()!=map.get(c1).intValue()){
                return map.get(c2)-map.get(c1);
            }else{
                return c1.compareTo(c2);
            }
        }
    });
 
 
    for(char c: map.keySet())
        queue.offer(c);
 
    StringBuilder sb = new StringBuilder();
 
    int len = str.length();
 
    while(!queue.isEmpty()){
 
        int cnt = Math.min(k, len);
        ArrayList<Character> temp = new ArrayList<Character>();
 
        for(int i=0; i<cnt; i++){
            if(queue.isEmpty())//\\
                return "";
 
            char c = queue.poll();
            sb.append(String.valueOf(c));
 
            map.put(c, map.get(c)-1);
 
            if(map.get(c)>0){
                temp.add(c);
            }
 
            len--;
        }
 
        for(char c: temp)
            queue.offer(c);//\\
    }
 
    return sb.toString();
}

for priorityqueue, if counts are same, you can compare the letter, so the order for polling out will be consistant.
https://discuss.leetcode.com/topic/49022/greedy-solution-beats-95
for example: "aaabbcc", k = 3
  1. Count the statistics of letters, sort them in terms of frequency in a descending way.
so it has the result: a - 3, b - 2, c - 2.
  1. Suppose the rewrite string length is len, divide the len into bins of size k, so in total
    you have
bin number of nBin = (len - 1) / k + 1,
with last bin size:
lastBinSize = len % k.
in the example, nBin = 3, lastBinSize = 1;
  1. Fill the same letter in different bins:
after filling 'a' ---> result = a##a##a
after filling 'b' ---> result = ab#ab#a
after filling 'c' ---> result = abcabca

http://dartmooryao.blogspot.com/2016/06/leetcode-358-rearrange-string-k.html
    public String rearrangeString(String str, int k) {
        if(k<=1){ return str; }
        int[] count = new int[26];
        for(int i=0; i<str.length(); i++){
            count[str.charAt(i)-'a']++;
        }
        PriorityQueue<int[]> pq = new PriorityQueue<>((a,b)->b[0]-a[0]);
        for(int i=0; i<count.length; i++){ pq.add(new int[]{ count[i], i}); }
       
        char[] result = new char[str.length()];
        int idx = 0;
        int start = 0;
        while(!pq.isEmpty()){
            int[] num = pq.remove();
            for(int i=0; i<num[0]; i++){
                result[idx] = (char)(num[1]+'a');
                if(idx>0 && result[idx-1]==result[idx]){ return ""; }
                idx+=k;
                if(idx>=str.length()){ idx=++start; }
            }
        }
        return new String(result);
    }
https://leetcode.com/discuss/108232/java_solution_in_12_ms-o-n-time-and-space
方法:根据出现频率将字母从大到小排列,以k为间隔进行重排。
https://leetcode.com/discuss/108174/c-unordered_map-priority_queue-solution-using-cache
http://www.cnblogs.com/grandyang/p/5586009.html
这道题给了我们一个字符串str,和一个整数k,让我们对字符串str重新排序,使得其中相同的字符之间的距离不小于k,这道题的难度标为Hard,看来不是省油的灯。的确,这道题的解法用到了哈希表,堆,和贪婪算法。这道题我最开始想的算法没有通过OJ的大集合超时了,下面的方法是参考网上大神的解法,发现十分的巧妙。我们需要一个哈希表来建立字符和其出现次数之间的映射,然后需要一个堆来保存这每一堆映射,按照出现次数来排序。然后如果堆不为空我们就开始循环,我们找出k和str长度之间的较小值,然后从0遍历到这个较小值,对于每个遍历到的值,如果此时堆为空了,说明此位置没法填入字符了,返回空字符串,否则我们从堆顶取出一对映射,然后把字母加入结果res中,此时映射的个数减1,如果减1后的个数仍大于0,则我们将此映射加入临时集合v中,同时str的个数len减1,遍历完一次,我们把临时集合中的映射对由加入堆
    string rearrangeString(string str, int k) {
        if (k == 0) return str;
        string res;
        int len = (int)str.size();
        unordered_map<char, int> m;
        priority_queue<pair<int, char>> q;
        for (auto a : str) ++m[a];
        for (auto it = m.begin(); it != m.end(); ++it) {
            q.push({it->second, it->first});
        }
        while (!q.empty()) {
            vector<pair<int, int>> v;
            int cnt = min(k, len);
            for (int i = 0; i < cnt; ++i) {
                if (q.empty()) return "";
                auto t = q.top(); q.pop();
                res.push_back(t.second);
                if (--t.first > 0) v.push_back(t);
                --len;
            }
            for (auto a : v) q.push(a);
        }
        return res;
    }
https://discuss.leetcode.com/topic/48125/java_solution_in_12_ms-o-n-time-and-space
    public String rearrangeString(String str, int k) {
        if(k < 2) return str;
      int[] times = new int[26];
      for(int i = 0; i < str.length(); i++){
          ++times[str.charAt(i) - 'a'];
      }
      SortedSet<int[]> set = new TreeSet<int[]>(new Comparator<int[]>(){
          @Override
          public int compare(int[] a, int[] b){
              return a[0] == b[0] ? Integer.compare(a[1], b[1]) : Integer.compare(b[0], a[0]);
          }
      });
      for(int i = 0; i < 26; i++){
          if(times[i] != 0){
            set.add(new int[]{times[i], i});
          }
      }
      int cycles = 0;
      int cur = cycles;
      Iterator<int[]> iter = set.iterator();
      char[] res = new char[str.length()];
      while(iter.hasNext()){
          int[] e = iter.next();
          for(int i = 0; i < e[0]; i++){
              res[cur] = (char)('a'+e[1]);
              if(cur > 0 && res[cur] == res[cur-1])
                return "";
              cur += k;
              if(cur >= str.length()){
                  cur = ++cycles;
              }
          }
      }
      return new String(res);
    }
http://blog.csdn.net/jmspan/article/details/51678257
方法:根据出现频率将字母从大到小排列,以k为间隔进行重排。
  1.     public String rearrangeString(String str, int k) {  
  2.         if (k <= 0return str;  
  3.         int[] f = new int[26];  
  4.         char[] sa = str.toCharArray();  
  5.         for(char c: sa) f[c-'a'] ++;  
  6.         int r = sa.length / k;  
  7.         int m = sa.length % k;  
  8.         int c = 0;  
  9.         for(int g: f) {  
  10.             if (g-r>1return "";  
  11.             if (g-r==1) c ++;  
  12.         }  
  13.         if (c>m) return "";  
  14.         Integer[] pos = new Integer[26];  
  15.         for(int i=0; i<pos.length; i++) pos[i] = i;  
  16.         Arrays.sort(pos, new Comparator<Integer>() {  
  17.            @Override  
  18.            public int compare(Integer i1, Integer i2) {  
  19.                return f[pos[i2]] - f[pos[i1]];  
  20.            }  
  21.         });  
  22.         char[] result = new char[sa.length];  
  23.         for(int i=0, j=0, p=0; i<sa.length; i++) {  
  24.             result[j] = (char)(pos[p]+'a');  
  25.             if (-- f[pos[p]] == 0) p ++;  
  26.             j += k;  
  27.             if (j >= sa.length) {  
  28.                 j %= k;  
  29.                 j ++;  
  30.             }  
  31.         }  
  32.         return new String(result);  
  33.     } 

方法二:最多允许有str.length() % k个冗余的字符,所以可以不排序,O(N)时间复杂度。

X.
https://discuss.leetcode.com/topic/48260/java-15ms-solution-with-two-auxiliary-array-o-n-time/
This looks like O(N^2) time because findValidMax() is linear.
Since the array is fixed size(26), it will take constant time to find max
This is a greedy problem.
Every time we want to find the best candidate: which is the character with the largest remaining count. Thus we will be having two arrays.
One count array to store the remaining count of every character. Another array to keep track of the most left position that one character can appear.
We will iterated through these two array to find the best candidate for every position. Since the array is fixed size, it will take constant time to do this.
After we find the candidate, we update two arrays.
    public String rearrangeString(String str, int k) {
        int length = str.length();
        int[] count = new int[26];
        int[] valid = new int[26];
        for(int i=0;i<length;i++){
            count[str.charAt(i)-'a']++;
        }
        StringBuilder sb = new StringBuilder();
        for(int index = 0;index<length;index++){
            int candidatePos = findValidMax(count, valid, index);
            if( candidatePos == -1) return "";
            count[candidatePos]--;
            valid[candidatePos] = index+k;
            sb.append((char)('a'+candidatePos));
        }
        return sb.toString();
    }
    
   private int findValidMax(int[] count, int[] valid, int index){
       int max = Integer.MIN_VALUE;
       int candidatePos = -1;
       for(int i=0;i<count.length;i++){
           if(count[i]>0 && count[i]>max && index>=valid[i]){
               max = count[i];
               candidatePos = i;
           }
       }
       return candidatePos;
   }
https://segmentfault.com/a/1190000005825133
//先记录str中的char及它出现在次数,存在count[]里,用valid[]来记录这个char最小出现的位置。
    //每一次把count值最大的数选出来,append到新的string后面
    public int selectedValue(int[] count, int[] valid, int i) {
        int select = Integer.MIN_VALUE;
        int val = -1;
        for (int j = 0; j < count.length; j++) {
            if (count[j] > 0 && i >= valid[j] && count[j] > select) {
                select = count[j];
                val = j;
            }
        }
        return val;
    }
    
    public String rearrangeString(String str, int k) {
        int[] count = new int[26];
        int[] valid = new int[26];
        //把每个出现了的char的个数记下来
        for (char c : str.toCharArray()) {
            count[c - 'a']++;
        }
        
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < str.length(); i++) {
            //选出剩下需要出现次数最多又满足条件的字母,即是我们最应该先放的数
            int curt = selectedValue(count, valid, i);
            //如果不符合条件,返回“”
            if (curt == -1) return "";
            //选择好后,count要减少,valid要到下一个k distance之后
            count[curt]--;
            valid[curt] = i + k;
            sb.append((char)('a' + curt));
        }
        
        return sb.toString();
    }
https://reeestart.wordpress.com/201
  1.     public String rearrangeString(String str, int k) {  
  2.         if (str == null || str.length() <= 1 || k <= 0return str;  
  3.         char[] sa = str.toCharArray();  
  4.         int[] frequency = new int[26];  
  5.         for(char ch : sa) {  
  6.             frequency[ch - 'a'] ++;  
  7.         }  
  8.         int bucketSize = sa.length / k;  
  9.         int remainSize = sa.length % k;  
  10.         int[] remain = new int[remainSize];  
  11.         int count = 0;  
  12.         for(int i = 0; i < frequency.length; i++) {  
  13.             if (frequency[i] > bucketSize + 1return "";  
  14.             if (frequency[i] > bucketSize && count >= remainSize) return "";  
  15.             if (frequency[i] > bucketSize) remain[count++] = i;  
  16.         }  
  17.           
  18.         int offset = 0, j = 0;  
  19.         for(int i = 0; i < count; i++) {  
  20.             while (frequency[remain[i]] > 0) {  
  21.                 frequency[remain[i]] --;  
  22.                 sa[j] = (char)('a' + remain[i]);  
  23.                 j += k;  
  24.                 if (j >= sa.length) {  
  25.                     offset ++;  
  26.                     j = offset;  
  27.                 }  
  28.             }  
  29.         }  
  30.           
  31.         for(int i = 0; i < 26; i ++) {  
  32.             while (frequency[i] > 0) {  
  33.                 frequency[i] --;  
  34.                 sa[j] = (char)('a' + i);  
  35.                 j += k;  
  36.                 if (j >= sa.length) {  
  37.                     offset ++;  
  38.                     j = offset;  
  39.                 }  
  40.             }  
  41.         }  
  42.         return new String(sa);  
  43.     }  
6/06/23/rearrange-string-with-k-distance-apart/
第一个是统计frequency用hash table vs int[]的区别,事实证明array的确要比hash table快一点(80+ms vs 110+ms)。无论input string是不是只包含小写字母,都可以用array来替代hash table,只是size大点小点的关系。
之前onsite面试的时候就已经被面试官不止一次的指出这个问题,能用array的时候就别用hash table.
第二个是sort vs TreeSet的区别。这个真是震惊了,不比不知道,一比下一跳,TreeSet的运行时间最低居然只有8ms,比sorting快了将近10倍。但理论上时间复杂度都是O(nlogn),为什么会这样有点理解不能…
  public String rearrangeString(String str, int k) {
    if (str == null || str.isEmpty() || k <= 1) {
      return str;
    }
    int[] cnt = new int[26];
    for (char c : str.toCharArray()) {
      cnt[c - 'a']++;
    }
//    List<int[]> entryList = new ArrayList<>();
//    for (int i = 0; i < 26; i++) {
//      if (cnt[i] != 0) {
//        entryList.add(new int[] {i, cnt[i]});
//      }
//    }
//    Collections.sort(entryList, (a, b) -> (-(a[1] - b[1])));
    TreeSet<int[]> entryList = new TreeSet<>(new Comparator<int[]>() {
      public int compare(int[] a, int[] b) {
        if (a[1] == b[1]) {
          return a[0] - b[0];
        }
        return -(a[1] - b[1]);
      }
    });
    for (int i = 0; i < 26; i++) {
      if (cnt[i] != 0) {
        entryList.add(new int[] {i, cnt[i]});
      }
    }
    char[] ch = new char[str.length()];
    int i = 0;
    int start = 1;
    for (int[] entry : entryList) {
      for (int j = 0; j < entry[1]; j++) {
        ch[i] = (char) (entry[0] + 'a');
        if (i != 0 && ch[i] == ch[i - 1]) {
          return "";
        }
        i += k;
        if (i >= str.length()) {
          i = start;
          start++;
        }
      }
    }
    return new String(ch);
  }
http://www.geeksforgeeks.org/check-whether-strings-k-distance-apart-not/
Given two strings, the task is to find if they are only less than or equal to k edit distance apart. It means that strings are only k edit distance apart when there are only k mismatches.
Print Yes if there are less than or equal to k mismatches, Else No.
Also print yes if both strings are already same.
1- Check if the difference in the length of both strings is greater than k if so , return false.
2- Find edit distance of two strings. If edit distance is less than or equal to k, return true. Else return false.
int editDistDP(string str1, string str2, int m, int n)
{
    // Create a table to store results of subproblems
    int dp[m+1][n+1];
    // Fill d[][] in bottom up manner
    for (int i=0; i<=m; i++)
    {
        for (int j = 0; j<=n; j++)
        {
            // If first string is empty, only option is to
            // insert all characters of second string
            if (i == 0)
                dp[i][j] = j;  // Min. operations = j
            // If second string is empty, only option is to
            // remove all characters of second string
            else if (j == 0)
                dp[i][j] = i; // Min. operations = i
            // If last characters are same, ignore last char
            // and recur for remaining string
            else if (str1[i-1] == str2[j-1])
                dp[i][j] = dp[i-1][j-1];
            // If last character are different, consider all
            // possibilities and find minimum
            else
                dp[i][j] = 1 + min(dp[i][j-1],  // Insert
                                   dp[i-1][j],  // Remove
                                   dp[i-1][j-1]); // Replace
        }
    }
    return dp[m][n];
}
// Returns true if str1 and str2 are k edit distance apart,
// else false.
bool areKDistant(string str1, string str2, int k)
{
    int m = str1.length();
    int n = str2.length();
    if (abs(m-n) > k)
        return false;
    return (editDistDP(str1, str2, m, n) <= k);
}

Labels

LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

Popular Posts